var A = Object.defineProperty;
var F = (e, t, s) => t in e ? A(e, t, { enumerable: !0, configurable: !0, writable: !0, value: s }) : e[t] = s;
var c = (e, t, s) => (F(e, typeof t != "symbol" ? t + "" : t, s), s);
import { DateTime as p, Duration as H } from "luxon";
class _ extends Error {
  /**
   * Creates a new instance of CalendarRangeError.
   *
   * @param code - The {@link ErrorCode} of the error.
   * @param message - The message of the error.
   */
  constructor(s, r) {
    super(r);
    c(this, "code");
    this.name = this.constructor.name, this.code = s, Error.captureStackTrace(this, this.constructor);
  }
}
class g extends _ {
  /**
   * Creates a new instance of InvalidParameterError.
   *
   * @param paramName - The name of the invalid parameter.
   * @param paramValue - The value of the invalid parameter.
   * @param expected - The expected type or format of the parameter value.
   * @param description - An optional description of the validation error.
   *
   * @example
   * ```
   * // create an instance of InvalidParameterError with some sample parameters
   *  const error = new InvalidParameterError(
   * 	"foo",
   * 	42,
   * 	"string",
   * 	"This option is required for the operation.",
   * );
   * // log the error to the console
   * console.log(error)
   * //-> Error: The value of the foo is invalid. You passed 42, but string is expected. This option is required for the operation.
   * ```
   */
  constructor(s, r, n, i) {
    const f = `The value of the ${s} is invalid. 
You passed ${JSON.stringify(
      r
    )}, but ${n} is expected.${i ? ` 
${i}` : ""}`;
    super("INVALID_PARAM", f);
    c(this, "paramName");
    c(this, "paramValue");
    c(this, "expected");
    c(this, "description");
    this.paramName = s, this.paramValue = r, this.expected = n, this.description = i;
  }
}
class C extends _ {
  /**
   * Represents an error that occurs when an argument is not provided but required in the function.
   * @param paramName - The name of the missing argument.
   * @param funcName - The name of the function where the error occurs.
   *
   * @example
   * ```
   * throw new MissingArgumentError("dateRange", "DateRange.getNext()")
   * // -> Error: Missing dateRange argument in DateRange.getNext() function.
   * ```
   */
  constructor(s, r) {
    const n = `Missing ${s} argument in ${r} function`;
    super("MISSING_PARAM", n);
    /**
     * The name of the missing argument.
     */
    c(this, "paramName");
    /**
     * The name of the function where the error occurs.
     */
    c(this, "funcName");
    this.paramName = s, this.funcName = r;
  }
}
class P extends _ {
  /**
   * @example
   * ```
   * throw new EmptyDateRangeError("getNext method");
   * // -> Error: The DateRange object you have passed to the getNext method is empty. You need to create a range using one of the get methods first'.
   * ```
   */
  constructor(s) {
    const r = `The DateRange object you have passed to the ${s} is empty. You need to create a range using one of the get methods first'.`;
    super("EMPTY_DATERANGE", r);
    c(this, "funcName");
    this.funcName = s;
  }
}
class X extends g {
  /**
   * Represents an error that occurs when the startOffset parameter is invalid.
   * @param paramValue - The value of the startOffset parameter that caused the error.
   */
  constructor(t) {
    const s = "startOffset", r = "a number >= 0";
    super(s, t, r);
  }
}
class L extends g {
  /**
   * Represents an error that occurs when the endOffset parameter is invalid.
   * @param paramValue - The value of the endOffset parameter that caused the error.
   */
  constructor(t) {
    const s = "endOffset", r = "a number >= 0";
    super(s, t, r);
  }
}
class q extends g {
  /**
   * Represents an error that occurs when the refWeekday parameter is invalid.
   * @param paramValue - The value of the refWeekday parameter that caused the error.
   */
  constructor(t) {
    const s = "refWeekday", r = "a number between 1 and 7.";
    super(s, t, r);
  }
}
class B extends g {
  /**
   * Represents an error that occurs when the refDate parameter is invalid.
   * @param paramValue - The value of the refDate parameter that caused the error.
   */
  constructor(t) {
    const s = "refDate", r = "Date object or luxon DateTime object.";
    super(s, t, r);
  }
}
class W extends g {
  /**
   * Represents an error that occurs when the dateRange parameter is invalid.
   * @param paramValue - The value of the dateRange parameter that caused the error.
   *
   * @example
   * ```
   * throw new InvalidDateRangeError(4)
   * // -> Error: The value of the dateRange parameter is invalid. You passed 4, but a valid, non empty DateRange object is expected.
   * ```
   */
  constructor(t) {
    const s = "dateRange parameter", r = "a valid, non empty DateRange object";
    super(s, t, r);
  }
}
function M(e) {
  return !(e === null || typeof e != "object" || e.constructor !== Object);
}
function $(e) {
  return !!(M(e) && Object.values(e).length === 0);
}
function G(e) {
  return typeof e == "number" && Number.isFinite(e);
}
function Q(e) {
  return !(!(e instanceof Date) || isNaN(e.getTime()));
}
function V(e) {
  return !!(e instanceof p && e.isValid);
}
function Z(e) {
  return !!(Array.isArray(e) && e.length !== 0 && e.every((t) => V(t)));
}
function N(e) {
  return typeof e == "number" && Number.isInteger(e);
}
function I(e) {
  return !!(Q(e) || V(e));
}
function Y(e) {
  if (typeof e != "string")
    return !1;
  try {
    return H.fromObject({ [e]: 1 }).isValid;
  } catch {
    return !1;
  }
}
function U(e) {
  return G(e) && Number.isInteger(e) && e >= 1 && e <= 7;
}
var z = /* @__PURE__ */ ((e) => (e[e.Monday = 1] = "Monday", e[e.Tuesday = 2] = "Tuesday", e[e.Wednesday = 3] = "Wednesday", e[e.Thursday = 4] = "Thursday", e[e.Friday = 5] = "Friday", e[e.Saturday = 6] = "Saturday", e[e.Sunday = 7] = "Sunday", e))(z || {}), y = /* @__PURE__ */ ((e) => (e.Week = "WEEK", e.MonthExact = "MONTH-EXACT", e.MonthExtended = "MONTH-EXTENDED", e.Days = "DAYS", e))(y || {});
const v = (e) => {
  if (!M(e) || $(e))
    throw new g("provided argument", e, "a non object");
}, D = (e) => {
  if (!N(e))
    throw new X(e);
}, w = (e) => {
  if (!N(e))
    throw new L(e);
}, E = (e) => {
  if (!U(e))
    throw new q(e);
}, x = (e) => {
  if (!I(e))
    throw new B(e);
}, K = (e) => {
  if (typeof e != "number")
    throw new g("daysCount param", e, "a number");
  if (!Number.isInteger(e) || e < 0)
    throw new g(
      "daysCount param",
      e,
      "a non-negative integer"
    );
}, J = {
  rangeToAdjust: "rangeToAdjust",
  startOffset: "startOffset",
  endOffset: "endOffset",
  timeUnit: "timeUnit"
}, S = Object.values(J);
function ee(e) {
  if (!M(e) || $(e))
    throw new g(
      "options parameter",
      e,
      `an object with all of the following properties: ${S.join(
        ", "
      )}`
    );
  if (Object.keys(e).filter(
    (f) => !(f in J)
  ).length > 0)
    throw new g(
      "ExtendDateRange options parameter",
      e,
      `an object with the following properties: ${S.join(
        ", "
      )}`
    );
  const { endOffset: s, rangeToAdjust: r, startOffset: n, timeUnit: i } = e;
  if (!Z(r))
    throw new g(
      "rangeToAdjust",
      r,
      "an array of DateTime"
    );
  if (!Y(i))
    throw new g(
      "timeUnit",
      i,
      "a string that is a DurationUnit",
      'DurationUnit is a string that represents a unit of time, such as "years", "months", "days", etc.`'
    );
  D(n), w(s);
}
function b(e) {
  ee(e);
  const { rangeToAdjust: t, timeUnit: s, endOffset: r, startOffset: n } = e;
  if (t.length + r < 1)
    throw new Error(
      `Negative endOffset (${r}) exceeds the date range length (${t.length}).`
    );
  if (t.length + n < 1)
    throw new Error(
      `Negative startOffset (${n}) exceeds the date range length (${t.length}).`
    );
  if (n < 0 && r < 0 && n + r + t.length < 1)
    throw new Error(
      `Negative values of startOffset (${n}) and endOffset (${r}) exceeds the date range length (${t.length}).`
    );
  const i = [...t], f = i[0], d = i[i.length - 1];
  if (n < 0)
    for (let a = 0; a > n; a--)
      i.shift();
  else
    for (let a = 1; a > 0 && a <= n; a++) {
      const o = f.minus({ [s]: a });
      i.unshift(o);
    }
  if (r < 0)
    for (let a = 0; a > r; a--)
      i.pop();
  else
    for (let a = 1; a > 0 && a <= r; a++) {
      const o = d.plus({ [s]: a });
      i.push(o);
    }
  return i;
}
const h = {
  rangeType: void 0,
  daysCount: 0,
  endOffset: 0,
  get refDate() {
    return p.now();
  },
  refWeekday: z.Monday,
  startOffset: 0,
  dateTimes: [],
  isNext: !1,
  isPrevious: !1
};
class T {
  /**
   * DateRange is an entry point for creating and storing a range of dates.
   *
   * @remarks
   * The dates can be generated with get methods.
   *
   * The constructor does not accept any parameters.
   */
  constructor() {
    /**
     * refDate of the instance.
     *
     * @remarks Default to current time.
     */
    c(this, "_refDate");
    /**
     * refWeekday of the instance.
     */
    c(this, "_refWeekday");
    /**
     * startOffset of the instance.
     */
    c(this, "_startOffset");
    /**
     * endOffset of the instance.
     */
    c(this, "_endOffset");
    /**
     * The instance dates storage.
     */
    c(this, "_dateTimes");
    /**
     * The type of a current generated date range.
     */
    c(this, "_rangeType");
    /**
     * Count of days used with getDays() method.
     */
    c(this, "_daysCount");
    /**
     * Indicates whether the DateRange is generated with a `getNext` method.
     */
    c(this, "_isNext");
    /**
     * Indicates whether the DateRange is generated with a `getPrevious` method.
     */
    c(this, "_isPrevious");
    if (arguments.length > 0)
      throw new g(
        "parameter passed to DateRange instance",
        // rome-ignore lint/style/noArguments: check specifically for empty arguments array
        arguments.length === 1 ? arguments[0] : [...arguments],
        "no parameters",
        "Option parameters should be specified within DateRange methods."
      );
  }
  /**
   * The reference date for this instance.
   */
  get refDate() {
    if (this._refDate === void 0)
      throw new Error(
        "You try to access refDate before it has been initialized. Call one of the getMethods to generate the range and set the refDate."
      );
    return this._refDate;
  }
  /**
   * The reference weekday for this instance.
   */
  get refWeekday() {
    if (this._refWeekday === void 0)
      throw new Error(
        "You try to access refWeekday before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._refWeekday;
  }
  /**
   * The array of luxon DateTimes for this instance.
   *
   * @remarks
   * To get JS Dates use `toJSDates()` method.
   */
  get dateTimes() {
    if (this._dateTimes === void 0)
      throw new Error(
        "You try to access dates before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._dateTimes;
  }
  /**
   * The start offset for this instance.
   */
  get startOffset() {
    if (this._startOffset === void 0)
      throw new Error(
        "You try to access startOffset property before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._startOffset;
  }
  /**
   * The end offset for this instance.
   */
  get endOffset() {
    if (this._endOffset === void 0)
      throw new Error(
        "You try to access endOffset property before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._endOffset;
  }
  /**
   * The days count used with `getDays()` method for this instance.
   */
  get daysCount() {
    if (this._daysCount === void 0)
      throw new Error(
        "You try to access daysCount property before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._daysCount;
  }
  /**
   * The type of range generated for this instance.
   *
   * @remarks
   * See {@link RANGE_TYPE| the RANGE_TYPE enum} for more details.
   *
   * If `undefined`, the range has not been created yet.
   *
   */
  get rangeType() {
    if (this._rangeType === void 0)
      throw new Error(
        "You try to access rangeType property before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._rangeType;
  }
  /**
   * A boolean that indicates whether DateRange is created with a `getNext` method.
   */
  get isNext() {
    if (this._isNext === void 0)
      throw new Error(
        "You try to access isNext property before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._isNext;
  }
  /**
   * A boolean that indicates whether DateRange is created with a `getPrevious` method.
   */
  get isPrevious() {
    if (this._isPrevious === void 0)
      throw new Error(
        "You try to access isPrevious property before it has been initialized. Call one of the getMethods to generate the range and set instance members."
      );
    return this._isPrevious;
  }
  /**
   * Sets or updates the instance members of the DateRange object.
   *
   * @param members - An object containing the properties of the DateRange object to be set or updated.
   * @private
   * */
  _setMembers(t) {
    const {
      rangeType: s,
      refDate: r,
      refWeekday: n,
      startOffset: i,
      endOffset: f,
      daysCount: d,
      dateTimes: a,
      isNext: o,
      isPrevious: u
    } = t;
    s !== this._rangeType && (this._rangeType = s), r !== this._refDate && (this._refDate = r instanceof Date ? p.fromJSDate(r) : r), n !== this._refWeekday && (this._refWeekday = n), i !== this._startOffset && (this._startOffset = i), f !== this._endOffset && (this._endOffset = f), d !== this._daysCount && (this._daysCount = d), o !== this._isNext && (this._isNext = o), u !== this._isPrevious && (this._isPrevious = u), this._dateTimes = a;
  }
  /*================================ Utility METHODS ==============================*/
  /**
   * Checks if a given value is a valid reference date.
   *
   * @remarks A reference date can be either a JS `Date` object or a Luxon `DateTime` object.
   *
   * @param refDate - The value to check.
   * @returns True if the value is a valid reference date, false otherwise.
   */
  isValidRefDate(t) {
    return I(t);
  }
  /**
   * Checks if a given value is a valid weekday (integer from 1 to 7).
   *
   * @param weekday - The value to check.
   * @returns True if weekday is an integer from 1 to 7, false otherwise.
   */
  isValidRefWeekday(t) {
    return U(t);
  }
  /**
   * Checks if a given value is a valid offset (non-negative integer).
   *
   * @param offset - The value to check.
   * @returns True if the value is a non-negative integer, false otherwise.
   */
  isValidOffset(t) {
    return N(t);
  }
  /*================================ CONVERTING METHODS ==============================*/
  /**
   * Returns an array of dates generated for the instance as Luxon DateTime objects.
   */
  toDateTimes() {
    return this.dateTimes;
  }
  /**
   * Returns an array of dates generated for the instance as JS Date objects.
   */
  toDates() {
    return this.dateTimes.map((t) => t.toJSDate());
  }
  /*================================ TIME RANGE METHODS ==============================*/
  /**
   * Creates a single week range.
   *
   * @remarks
   * - By default, the method starts the range on Monday before or on the reference date and ends
   * it on Sunday after or on the reference date.
   *
   * - If not specified, the reference date is set to the current time.
   *
   * - Each date is set to the start of the day (midnight).
   *
   * @param options - An optional object to customize the date range.
   * @returns The `DateRange` with generated dates.
   *
   * @example
   *  ```
   * // get current week starting on Monday
   * const week1 = new DateRange().getWeek();
   *
   * // get week based on a refDate and starting on Sunday
   * const week2 = new DateRange().getWeek({
   * 	refDate: new Date("2023-01-10"),
   * 	refWeekday: WEEKDAY.Sunday,
   * });
   * // Generated dates:👇
   * // Sunday, January 8, 2023 at 12:00:00 AM
   * // Monday, January 9, 2023 at 12:00:00 AM
   * // Tuesday, January 10, 2023 at 12:00:00 AM
   * // Wednesday, January 11, 2023 at 12:00:00 AM
   * // Thursday, January 12, 2023 at 12:00:00 AM
   * // Friday, January 13, 2023 at 12:00:00 AM
   * // Saturday, January 14, 2023 at 12:00:00 AM
   * ```
   */
  getWeek(t) {
    if (t !== void 0) {
      v(t);
      const { refDate: u, refWeekday: m, endOffset: l, startOffset: O } = t;
      u !== void 0 && x(u), m !== void 0 && E(m), O !== void 0 && D(O), l !== void 0 && w(l);
    }
    const {
      refDate: s = h.refDate,
      refWeekday: r = h.refWeekday,
      startOffset: n = h.startOffset,
      endOffset: i = h.endOffset
    } = t || {}, f = {
      rangeType: y.Week,
      dateTimes: [],
      refDate: s,
      refWeekday: r,
      endOffset: i,
      startOffset: n,
      isNext: h.isNext,
      isPrevious: h.isPrevious,
      daysCount: h.daysCount
    };
    let d;
    for (s instanceof Date ? d = p.fromJSDate(s).startOf("day") : d = s.startOf("day"); d.weekday !== r; )
      d = d.minus({ days: 1 });
    const a = f.dateTimes;
    let o = d;
    for (; a.length < 7; )
      a.push(o), o = o.plus({ day: 1 });
    if (n || i) {
      const u = b({
        rangeToAdjust: a,
        timeUnit: "days",
        startOffset: n,
        endOffset: i
      });
      return this._setMembers({
        ...f,
        dateTimes: [...u]
      }), this;
    } else
      return this._setMembers(f), this;
  }
  /**
   *
   * Creates a single month range extended to include the full weeks.
   *
   * @remarks
   *
   * - By default, the method starts the range on Monday before or on the first day of the month and ends
   * it on Sunday after or on the last day of the month.
   *
   * - If not specified, the reference date is set to the current time.
   *
   * - Each date is set to the start of the day (midnight).
   *
   * @param options - An optional object to customize the date range.
   * @returns The `DateRange` with generated dates.
   * @example
   *  ```
   * // Get current month extended to full weeks
   * const monthExtended1 = new DateRange().getMonthExtended();
   *
   * // Get month extended to full weeks based on a refDate and starting on Wednesday
   * const monthExtended2 = new DateRange().getMonthExtended({
   * 	refDate: new Date("2023-01-10"),
   * 	refWeekday: WEEKDAY.Wednesday,
   * });
   * // Generated dates:
   * // Wednesday, December 28, 2022 at 12:00:00 AM -> The first date of the range
   * // Thursday, December 29, 2022 at 12:00:00 AM
   * // Friday, December 30, 2022 at 12:00:00 AM
   * // ...
   * // Tuesday, January 31, 2023 at 12:00:00 AM -> The last date of the range
   * ```
   */
  getMonthExtended(t) {
    if (t !== void 0) {
      v(t);
      const { refDate: O, refWeekday: k, endOffset: R, startOffset: j } = t;
      O !== void 0 && x(O), k !== void 0 && E(k), j !== void 0 && D(j), R !== void 0 && w(R);
    }
    const {
      refDate: s = h.refDate,
      refWeekday: r = h.refWeekday,
      startOffset: n = h.startOffset,
      endOffset: i = h.endOffset
    } = t || {}, f = {
      rangeType: y.MonthExtended,
      dateTimes: [],
      refDate: s,
      refWeekday: r,
      endOffset: i,
      startOffset: n,
      isNext: h.isNext,
      isPrevious: h.isPrevious,
      daysCount: h.daysCount
    }, d = r - 1 === 0 ? 7 : r - 1;
    let a, o;
    s instanceof Date ? (a = p.fromJSDate(s).startOf("month"), o = p.fromJSDate(s).endOf("month")) : (a = s.startOf("month"), o = s.endOf("month"));
    const u = f.dateTimes;
    let m = a;
    for (; m.weekday !== r; )
      m = m.minus({ days: 1 });
    let l = m;
    for (; l.valueOf() < o.valueOf(); )
      u.push(l), l = l.plus({ day: 1 });
    for (; u[u.length - 1].weekday !== d; )
      u.push(u[u.length - 1].plus({ days: 1 }));
    if (n || i) {
      const O = b({
        rangeToAdjust: u,
        timeUnit: "days",
        startOffset: n,
        endOffset: i
      });
      return this._setMembers({
        ...f,
        dateTimes: [...O]
      }), this;
    } else
      return this._setMembers(f), this;
  }
  /**
   * Creates a single month range, from the first to the last day of the month.
   *
   * @remarks
   *
   * - By default, the method starts the range on the first day of the month and ends
   * it on the last day of the month.
   *
   * - If not specified, the reference date is set to the current time.
   *
   * - Each date is set to the start of the day (midnight).
   *
   * @param options - An optional object to customize the date range.
   * @returns The `DateRange` with generated dates.
   * @example
   *  ```
   * // Get current month
   * const month1 = new DateRange().getMonthExact();
   *
   * // Get month with specified refDate
   * const month2 = new DateRange().getMonthExact({
   * 	refDate: new Date("2023-01-10"),
   * });
   * // Generated dates:
   * // Sunday, January 1, 2023 at 12:00:00 AM -> The first date of the range
   * // Monday, January 2, 2023 at 12:00:00 AM
   * // Tuesday, January 3, 2023 at 12:00:00 AM
   * // ...
   * // Tuesday, January 31, 2023 at 12:00:00 AM -> The last date of the range
   *
   * // Get month with specified refDate and offsets
   * const month3 = new DateRange().getMonthExact({
   * 	refDate: new Date("2023-01-10"),
   * 	startOffset: 2,
   * 	endOffset: 2,
   * });
   * // Friday, December 30, 2022 at 12:00:00 AM  -> The range starts 2 days before default first day
   * // Saturday, December 31, 2022 at 12:00:00 AM
   * // Sunday, January 1, 2023 at 12:00:00 AM
   * // ...
   * // Tuesday, January 31, 2023 at 12:00:00 AM
   * // Wednesday, February 1, 2023 at 12:00:00 AM
   * // Thursday, February 2, 2023 at 12:00:00 AM -> The range ends 2 days after default last day
   * ```
   */
  getMonthExact(t) {
    if (t !== void 0) {
      v(t);
      const { refDate: u, endOffset: m, startOffset: l } = t;
      u !== void 0 && x(u), l !== void 0 && D(l), m !== void 0 && w(m);
    }
    const {
      refDate: s = h.refDate,
      startOffset: r = h.startOffset,
      endOffset: n = h.endOffset
    } = t || {}, i = {
      rangeType: y.MonthExact,
      dateTimes: [],
      refDate: s,
      refWeekday: h.refWeekday,
      endOffset: n,
      startOffset: r,
      isNext: h.isNext,
      isPrevious: h.isPrevious,
      daysCount: h.daysCount
    };
    let f, d;
    s instanceof Date ? (f = p.fromJSDate(s).startOf("month"), d = p.fromJSDate(s).endOf("month")) : (f = s.startOf("month"), d = s.endOf("month"));
    const a = i.dateTimes;
    let o = f;
    for (; o.valueOf() < d.valueOf(); )
      a.push(o), o = o.plus({ day: 1 });
    if (r || n) {
      const u = b({
        rangeToAdjust: a,
        timeUnit: "days",
        startOffset: r,
        endOffset: n
      });
      return this._setMembers({
        ...i,
        dateTimes: [...u]
      }), this;
    } else
      return this._setMembers(i), this;
  }
  /**
   * Creates a range of custom number of days.
   *
   * @remarks
   * - The reference date is a starting point of the range.
   *
   * - If not specified, the reference date is set to the current day.
   *
   * - The length of the range can be specified with the `daysCount` property in the `options` object.
   * If not specified, the range will be created with a single date.
   *
   * - Each date is set to the start of the day (midnight).
   *
   * @param options - An optional object to customize the date range.
   * @returns The DateRange with generated dates.
   * @example
   * ```
   * // Get a current date
   * const range1 = new DateRange().getDays();
   *
   * // Get a range of 10 days starting on 2023-01-10
   * const range2 = new DateRange().getDays({
   * 	daysCount: 10,
   * 	refDate: new Date("2023-01-10"),
   * });
   * // Generated dates:
   * // January 10, 2023 at 12:00:00 AM
   * // January 11, 2023 at 12:00:00 AM
   * // January 12, 2023 at 12:00:00 AM
   * // January 13, 2023 at 12:00:00 AM
   * // January 14, 2023 at 12:00:00 AM
   * // January 15, 2023 at 12:00:00 AM
   * // January 16, 2023 at 12:00:00 AM
   * // January 17, 2023 at 12:00:00 AM
   * // January 18, 2023 at 12:00:00 AM
   * // January 19, 2023 at 12:00:00 AM
   * ```
   */
  getDays(t) {
    if (t !== void 0) {
      v(t);
      const { refDate: u, endOffset: m, startOffset: l, daysCount: O } = t;
      u !== void 0 && x(u), l !== void 0 && D(l), m !== void 0 && w(m), O !== void 0 && K(O);
    }
    const {
      refDate: s = h.refDate,
      startOffset: r = h.startOffset,
      endOffset: n = h.endOffset,
      daysCount: i = 1
    } = t || {}, f = {
      rangeType: y.Days,
      dateTimes: [],
      refDate: s,
      refWeekday: h.refWeekday,
      endOffset: n,
      startOffset: r,
      isNext: h.isNext,
      isPrevious: h.isPrevious,
      daysCount: i
    };
    let d;
    s instanceof Date ? d = p.fromJSDate(s).startOf("day") : d = s.startOf("day");
    const a = f.dateTimes;
    let o = d;
    for (; a.length < i; )
      a.push(o), o = o.plus({ day: 1 });
    if (r || n) {
      const u = b({
        rangeToAdjust: a,
        timeUnit: "days",
        startOffset: r,
        endOffset: n
      });
      return this._setMembers({
        ...f,
        dateTimes: [...u]
      }), this;
    } else
      return this._setMembers(f), this;
  }
  /**
   *
   * Generates the next range based on given one.
   *
   * @remarks
   * The method takes a DateRange object and based on its range type,
   * sets the refDate to a date that can generate the new range.
   *
   * It copies the options used to adjust the given range and applies them to the new range.
   *
   * The method shifts the refDate to the next one as follows:
   * - for a range generated with getDays, the refDate is incremented by the daysCount property.
   * - for a range generated with getWeek, the refDate is incremented by 7 days.
   * - for a range generated with getMonthExact and getMonthExtended, the refDate is set to the first day of the next month.
   *
   * In all cases, the refDate is set to the start of the day (midnight).
   *
   * To check whether the DaterRange is generated with a getNext method, access the `isNext` property of a DateRange instance.
   *
   * @param dateRange - A DateRange object with a generated range.
   * @returns The DateRange with generated dates.
   * @throws an error if DateRange is not provided or the range is not initialized.
   *
   * @example
   * ```
   * // example with a "WEEK" range
   * const week = new DateRange().getWeek({ refDate: new Date("2023-01-10") });
   * week.dateTimes; // dates from Mon, 01/09/2023 to Sun, 01/15/2023
   *
   * const weekNext = new DateRange().getNext(week);
   * weekNext.dateTimes; // dates from Mon, 01/16/2023 to Sun, 01/22/2023
   * ```
   */
  getNext(t) {
    if (t === void 0)
      throw new C("dateRange", "DateRange.getNext()");
    if (!(t instanceof T))
      throw new W(t);
    try {
      t.rangeType;
    } catch {
      throw new P("getNext method");
    }
    const {
      refDate: s,
      startOffset: r,
      endOffset: n,
      refWeekday: i,
      rangeType: f,
      daysCount: d
    } = t;
    switch (f) {
      case y.Week: {
        const o = {
          refDate: s.startOf("day").plus({ days: 7 }),
          refWeekday: i,
          startOffset: r,
          endOffset: n
        };
        return this.getWeek(o), this._isNext = !0, this;
      }
      case y.MonthExact: {
        const o = {
          refDate: s.startOf("month").plus({ month: 1 }),
          startOffset: r,
          endOffset: n
        };
        return this.getMonthExact(o), this._isNext = !0, this;
      }
      case y.MonthExtended: {
        const a = s.startOf("month").plus({ month: 1 }), o = {
          refWeekday: i,
          refDate: a,
          startOffset: r,
          endOffset: n
        };
        return this.getMonthExtended(o), this._isNext = !0, this;
      }
      case y.Days: {
        const a = s.startOf("day").plus({ day: d }), o = {
          daysCount: d,
          endOffset: n,
          startOffset: r,
          refDate: a
        };
        return this.getDays(o), this._isNext = !0, this;
      }
      default:
        throw new Error("not implemented");
    }
  }
  /**  Generates the previous range based on given one.
   *
   * @remarks
   *
   * The method takes a DateRange object and based on its range type,
   * sets the refDate to a date that can generate the new range.
   *
   * It copies the options used to adjust the given range and applies them to the new range.
   *
   * The method shifts the refDate to the previous one as follows:
   *   - for a range generated with getDays, the refDate is decremented by the daysCount property.
   *   - for a range generated with getWeek, the refDate is decremented by 7 days.
   *   - for a range generated with getMonthExact and getMonthExtended, the refDate is set to the first day of the previous month.
   *
   * In all cases, the refDate is set to the start of the day (midnight).
   *
   * To check whether the DaterRange is generated with a getPrevious method, access the `isPrevious` property of a DateRange instance.
   *
   * @param dateRange - A DateRange object with a generated range range.
   * @returns The DateRange object with a generated range of the same type and options as the given one but with shifted dates.
   * @throws an error if DateRange is not provided or the range is not initialized.
   *
   * @example
   * ```
   * // example with a "WEEK" range
   * const week = new DateRange().getWeek({ refDate: new Date("2023-01-10") });
   * week.dateTimes; // dates from Mon, 01/09/2023, to Sun, 01/15/2023
   *
   * const weekPrevious = new DateRange().getPrevious(week);
   * weekPrev.dateTimes; // dates from Mon, 01/02/2023 to Sun, 01/08/2023
   * ```
   */
  getPrevious(t) {
    if (t === void 0)
      throw new C("dateRange", "DateRange.getPrevious");
    if (!(t instanceof T))
      throw new W(t);
    try {
      t.rangeType;
    } catch {
      throw new P("getPrevious method");
    }
    const {
      refDate: s,
      startOffset: r,
      endOffset: n,
      refWeekday: i,
      rangeType: f,
      daysCount: d
    } = t;
    switch (f) {
      case y.Week: {
        const o = {
          refDate: s.startOf("day").minus({ days: 7 }),
          refWeekday: i,
          startOffset: r,
          endOffset: n
        };
        return this.getWeek(o), this._isPrevious = !0, this;
      }
      case y.MonthExact: {
        const o = {
          refDate: s.startOf("month").minus({ month: 1 }),
          startOffset: r,
          endOffset: n
        };
        return this.getMonthExact(o), this._isPrevious = !0, this;
      }
      case y.MonthExtended: {
        const a = s.startOf("month").minus({ month: 1 }), o = {
          refWeekday: i,
          refDate: a,
          startOffset: r,
          endOffset: n
        };
        return this.getMonthExtended(o), this._isPrevious = !0, this;
      }
      case y.Days: {
        const a = s.startOf("day").minus({ day: d }), o = {
          daysCount: d,
          endOffset: n,
          startOffset: r,
          refDate: a
        };
        return this.getDays(o), this._isPrevious = !0, this;
      }
      default:
        throw new Error("not implemented");
    }
  }
}
export {
  T as DateRange
};
