/**
 * Checks if an object has all the expected keys and optionally no extra keys.
 *
 * @param object - The object to check.
 * @param keys - The array of expected keys.
 * @param mode - The mode of checking. If "default", only checks for the presence of expected keys. If “strict”, also checks that the object does not have any extra keys.
 * @returns True if the object has all the expected keys and optionally no extra keys, false otherwise.
 * @throws InvalidParameterError if any of the parameters are invalid.
 */
export declare function hasExpectedKeys(object: unknown, keys: string[], mode?: "default" | "strict"): boolean;
